foundation-0.0.30: Alternative prelude with batteries and no dependencies

Safe Haskell | None
Language | Haskell2010

Foundation.Monad.Except

# Documentation

newtype ExceptT e (m :: Type -> Type) a #

Constructors

ExceptT |

Fields

- runExceptT :: m (Either e a)

#### Instances

Instances details

MonadTrans (ExceptT e) # |
Instance details Defined in Foundation.Monad.Except Methods lift :: Monad m => m a -> ExceptT e m a #
MonadIO m => MonadIO (ExceptT e m) # |
Instance details Defined in Foundation.Monad.Except Methods liftIO :: IO a -> ExceptT e m a #
Monad m => MonadFailure (ExceptT e m) # |

Instance details

Defined in Foundation.Monad.Except

Associated Types

type Failure (ExceptT e m) |
Instance details Defined in Foundation.Monad.Except type Failure (ExceptT e m) = e

Methods

mFail :: Failure (ExceptT e m) -> ExceptT e m () #

MonadReader m => MonadReader (ExceptT e m) # |

Instance details

Defined in Foundation.Monad.Except

Associated Types

type ReaderContext (ExceptT e m) |
Instance details Defined in Foundation.Monad.Except type ReaderContext (ExceptT e m) = ReaderContext m

Methods

ask :: ExceptT e m (ReaderContext (ExceptT e m)) #

Monad m => Applicative (ExceptT e m) # |
Instance details Defined in Foundation.Monad.Except Methods pure :: a -> ExceptT e m a # (<*>) :: ExceptT e m (a -> b) -> ExceptT e m a -> ExceptT e m b # liftA2 :: (a -> b -> c) -> ExceptT e m a -> ExceptT e m b -> ExceptT e m c # (*>) :: ExceptT e m a -> ExceptT e m b -> ExceptT e m b # (<*) :: ExceptT e m a -> ExceptT e m b -> ExceptT e m a #
Functor m => Functor (ExceptT e m) # |
Instance details Defined in Foundation.Monad.Except Methods fmap :: (a -> b) -> ExceptT e m a -> ExceptT e m b # (<$) :: a -> ExceptT e m b -> ExceptT e m a #
Monad m => Monad (ExceptT e m) # |
Instance details Defined in Foundation.Monad.Except Methods (>>=) :: ExceptT e m a -> (a -> ExceptT e m b) -> ExceptT e m b # (>>) :: ExceptT e m a -> ExceptT e m b -> ExceptT e m b # return :: a -> ExceptT e m a #
MonadFail m => MonadFail (ExceptT e m) # |
Instance details Defined in Foundation.Monad.Except Methods fail :: String -> ExceptT e m a #
(Monad m, MonadFix m) => MonadFix (ExceptT e m) # |
Instance details Defined in Foundation.Monad.Except Methods mfix :: (a -> ExceptT e m a) -> ExceptT e m a #
type Failure (ExceptT e m) # |
Instance details Defined in Foundation.Monad.Except type Failure (ExceptT e m) = e
type ReaderContext (ExceptT e m) # |
Instance details Defined in Foundation.Monad.Except type ReaderContext (ExceptT e m) = ReaderContext m